'Counetr Program for Vin-Kit By Behnam Zakizadeh @ 31.01.91 [2012]
'Comm Anode Red Seg

$regfile = "m8def.dat"
$crystal = 1000000
$hwstack = 40
$swstack = 16
$framesize = 32

'I/O
'Come Anodes 1 2 3 4
Config Pind.0 = Output                                      '1000
Config Pind.6 = Output                                      '0200
Config Pind.7 = Output                                      '0030
Config Pind.5 = Output                                      '0004

'Segments a b c d e f g
Config Pind.1 = Output                                      'a
Config Pinb.0 = Output                                      'b
Config Pinb.2 = Output                                      'c
Config Pinb.4 = Output                                      'd
Config Pinb.5 = Output                                      'e
Config Pind.2 = Output                                      'f
Config Pinb.1 = Output                                      'g

'Key's
Config Pind.3 = Input                                       'Down Key
Config Pind.4 = Input                                       'Up Key
Config Pinb.6 = Input                                       'Reset Key

Set Portd.3
Set Portd.4
Set Portb.6

'Aliases
Up_key Alias Pind.4
Down_key Alias Pind.3
Reset_key Alias Pinb.6

Seg_a Alias Portd.1
Seg_b Alias Portb.0
Seg_c Alias Portb.2
Seg_d Alias Portb.4
Seg_e Alias Portb.5
Seg_f Alias Portd.2
Seg_g Alias Portb.1

Comm_1 Alias Portd.0
Comm_2 Alias Portd.6
Comm_3 Alias Portd.7
Comm_4 Alias Portd.5

'Variable's
Dim Count As Word , A As Word , B As Word , C As Word

'Declaration
Declare Sub Refresh
Declare Sub Send
Declare Sub Rst7
Declare Sub Rst

'Main Prog Start Here:
Do
   Call Send
   '********** Key ***********
   If Up_key = 0 Then
      Incr Count
      If Count > 9999 Then Count = 0
      While Up_key = 0
         Call Send
      Wend
   End If
   If Down_key = 0 Then
      If Count > 0 Then Decr Count
      While Down_key = 0
         Call Send
      Wend
   End If
   If Reset_key = 0 Then Count = 0
Loop

Sub Send
   If Count < 10 Then
      Call Rst : Set Comm_4 : A = Count : Call Refresh
   End If
   If Count >= 10 And Count <= 99 Then
      Call Rst : Set Comm_4 : A = Count Mod 10 : Call Refresh
      Call Rst : Set Comm_3 : A = Count \ 10 : Call Refresh
   End If
   If Count >= 100 And Count <= 999 Then
      Call Rst : Set Comm_4 : A = Count Mod 10 : Call Refresh : B = Count \ 10
      Call Rst : Set Comm_3 : A = B Mod 10 : Call Refresh
      Call Rst : Set Comm_2 : A = B \ 10 : Call Refresh
   End If
   If Count >= 1000 And Count <= 9999 Then
      Call Rst : Set Comm_4 : A = Count Mod 10 : Call Refresh : B = Count \ 10
      Call Rst : Set Comm_3 : A = B Mod 10 : Call Refresh : C = B \ 10
      Call Rst : Set Comm_2 : A = C Mod 10 : Call Refresh
      Call Rst : Set Comm_1 : A = C \ 10 : Call Refresh
   End If

End Sub

Sub Rst
   Reset Comm_1
   Reset Comm_2
   Reset Comm_3
   Reset Comm_4
End Sub

Sub Rst7
   Set Seg_a
   Set Seg_b
   Set Seg_c
   Set Seg_d
   Set Seg_e
   Set Seg_f
   Set Seg_g
End Sub

Sub Refresh
    Call Rst7
    Select Case A
    Case 0:
       Seg_a = 0
       Seg_b = 0
       Seg_c = 0
       Seg_d = 0
       Seg_e = 0
       Seg_f = 0
    Case 1:
       Seg_b = 0
       Seg_c = 0
    Case 2:
       Seg_a = 0
       Seg_b = 0
       Seg_d = 0
       Seg_e = 0
       Seg_g = 0
    Case 3:
       Seg_a = 0
       Seg_b = 0
       Seg_c = 0
       Seg_d = 0
       Seg_g = 0
    Case 4:
       Seg_b = 0
       Seg_c = 0
       Seg_f = 0
       Seg_g = 0
    Case 5:
       Seg_a = 0
       Seg_c = 0
       Seg_d = 0
       Seg_f = 0
       Seg_g = 0
    Case 6:
       Seg_a = 0
       Seg_c = 0
       Seg_d = 0
       Seg_e = 0
       Seg_f = 0
       Seg_g = 0
    Case 7:
       Seg_a = 0
       Seg_b = 0
       Seg_c = 0
    Case 8:
       Seg_a = 0
       Seg_b = 0
       Seg_c = 0
       Seg_d = 0
       Seg_e = 0
       Seg_f = 0
       Seg_g = 0
    Case 9:
       Seg_a = 0
       Seg_b = 0
       Seg_c = 0
       Seg_d = 0
       Seg_f = 0
       Seg_g = 0
    End Select
    Waitms 4
    Call Rst7                                                   'Clear Screen
End Sub

End